/**

	3D Billiards Demo
	
	File			:	Ball Class Header

	Created by		:	Reznichenko Anton aka AlterVision
						mailto:me@av13.ru
						http://www.av13.ru

	Project started :	14 may 2009 - 12:27
	Last edited		:	18 may 2009 - 19:30

*/


#pragma once

// Vector-Point Type Definition
typedef struct _vector_point_t {
	float x, y, z;	// 3d-coordinate
} vp_t, *vp_p;

// Ball Class Definition
typedef class c_ball {

public:

	// Routine
	c_ball	(int id);
	~c_ball ();

	// Basics
	int				id;				// Object ID
	int				active;			// Object is Active
	int				mutex;			// Locking Mutex
	int				material;		// Object Draw Color

	// Basic Properties
	vp_t			position;		// Position
	vp_t			speed;			// Moving Vector
	float			air;			// Air Resistance
	int				size;			// Object Size
	int				mass;			// Object Mass

	// Basic Processing Functions
	int				create		(void * vworld, vp_t position);
	int				destroy		(void * vworld);
	int				process		(void * vworld);
	int				render		(void * vworld);

	// Force The Vector 
	int				vector		(vp_t force);	
	
	// Process Collision (returns new vector of collide object)
	vp_t			collide		(vp_t position, vp_t speed, float mass);

	// Process Syncronization
	void			lock		();
	void			unlock		();

} c_ball_t, *c_ball_p;
