/**

	3D Billiards Demo
	
	File			:	Interface Class Header

	Created by		:	Reznichenko Anton aka AlterVision
						mailto:me@av13.ru
						http://www.av13.ru

	Project started :	14 may 2009 - 12:27
	Last edited		:	18 may 2009 - 19:28

*/

#pragma once

#define MAX_SPEED 1.0
#define XROTATE_SPEED 1.5
#define YROTATE_SPEED 3.0

typedef class c_iface {

public:

	// Routines
	c_iface ();
	~c_iface ();

	// Basics
	int		view;			// View Type (0 - global, 1 - ball)

	// View Mode Zero
	float	x, y, z;		// View Coordinates
	float	cx, cy, cz;		// Camera Coordinates
	float	ws, ss;			// Move Speeds
	float	xa, ya;			// Angles
	float	xas, yas;		// Angle Change Speed
	float	camera;			// Camera Distance

	// View Mode One
	float	vxa, vya;		// View Camera Angles
	float	vxs, vys;		// View Camera Speed
	float	vdis;			// View Camera Distance
	int		view_id;		// Viewing Object ID

	// Basic Functions
	int		process (void * vworld);	// Key Handling
	void	look	(void * vworld);	// Rendering

private:

	// Gradus to Radians conWerter
	float	wg2r	(float angle);

} c_iface_t, *c_iface_p;