/**

	3D Billiards Demo
	
	File			:	World Class Header

	Created by		:	Reznichenko Anton aka AlterVision
						mailto:me@av13.ru
						http://www.av13.ru

	Project started :	14 may 2009 - 12:27
	Last edited		:	18 may 2009 - 19:27

*/

#pragma once

#define null 0

#define	DRAW_TIMEOUT		25

#define MAX_OBJECTS			100
#define COUNT_INC			10

#define BOX_SIZE_X			10.0f
#define BOX_SIZE_Y			10.0f
#define BOX_SIZE_Z			10.0f

#include "iface.h"
#include "ball.h"

typedef class c_world {

public:

	c_world ();
	~c_world ();

	//
	// General Functions
	//

	void		create	();
	void		render	();
	void		destroy	();

	//
	// Processing Thread Functions
	//

	void		process	();
	void		collider();

	c_iface_p	iface;

	//
	// Global Draw Variables
	//

	// Window
	int			win_x, win_y;		// Window Position
	int			win_cx, win_cy;		// Window Center Position
	int			screen_x, screen_y;	// Window Size
	// Keys
	int			keys[256];			// Keys State
	int			keyp[256];			// Keys Pressed
	// Mouse
	int			mx, my;				// mouse x/y
	int			mmx, mmy;			// mouse move x/y

	//
	// Context And General Game
	//

	c_ball_p	get_object_by_id (int id);

	int			create_object (vp_t position);
	int			delete_object (int id);

	int			next_object_id (int id);
	int			prev_object_id (int id);

	void*		quadric;

//private:

	int			create_object_ptr;

	c_ball_p	objects[MAX_OBJECTS];
	int			objects_count;		// Objects Count
	int			objects_ptr;		// Selection Pointer
	c_ball_p	get_next_object ();
	void		reset_objects ();

} c_world_t, *c_world_p;
